; SLDFAC.LSP - Created By Lintang Darudjati
; Automate process of creating slides

(defun C:SLDFAC ( /   zStrParse zSlashPath zExtractPath zEDS zEDL zStrPart zMsgBox zCE 
                      strp cp lenp ;isdos
                      _a _aa
                      tempdir 
                      dir 
                      islib
                      libname 
                      dwglist
                      namelist
                      zgetfnames
                      zgocreate
                      olderr
                  )
	(if (/= (getvar "SDI") nil) (setvar "SDI" 1))
        (setq olderr *ERROR*)(defun *ERROR* (msg)(setq *ERROR* olderr)(princ "\nSlide Factory terminated")
          (princ)
        )
; ===========================================================================================
; ROUTINES
; -------------------------------------------------------------------------------------------
; MEM-PARSE STRING DENGAN PEMISAH CHARACTER-CHARACTER TERTENTU
; str       : input string
; delimlst  : list of delimiter chars. =  '("/" ":" "\\")
; blank     : allow blank fields
;   T=("abc" "" "def" "" "ghi"), NIL=("abc" "def" "ghi")

(defun zStrParse ( str delimlst blank / currchar idx tempstr strlength strlist )
  (setq strlength (strlen str) idx 0 tempstr "")
  (while (< idx strlength)
    (if (member (setq currchar (substr str (setq idx (1+ idx)) 1)) delimlst)
      (progn
        (if (or blank (/= tempstr ""))(setq strlist (append strlist (list tempstr))))
        (setq tempstr "")
      )
      (setq tempstr (strcat tempstr currchar))
    )
  )
  (if (and (null blank) (= tempstr ""))
    strlist
    (append strlist (list tempstr))
  )
); Return list of string or NIL

; -------------------------------------------------------------------------------------------

(defun zSlashPath ( str / ret)
  (if (/= "\\" (substr str (strlen str) 1))
    (setq ret (strcat str "\\"))
    (setq ret str)
  ) ret
)
  
; -------------------------------------------------------------------------------------------
; Extract path from full filename
; flag=T   -> with '//' at the end of path-string 
; flag=nil -> without '//' at the end of path-string
; Returns string if success, nil otherwise
 
(defun zExtractPath ( fname flag / tmplist c len str)
  (if fname
    (progn
      (setq tmplist (zStrParse fname '("\\") nil))
      (setq tmplist (reverse (cdr (reverse tmplist))))
      (setq c 0)
      (setq len (length tmplist))
      (setq str "")
      (while (< c len)
        (setq str (strcat str (nth c tmplist)))
        (if (= flag nil)
          (if (/= c (1- len))(setq str (strcat str "\\"))) ;without end
          (setq str (strcat str "\\")) ;with end
        )
        (setq c (1+ c))
      )
      str
    )
  )
)
; -------------------------------------------------------------------------------------------
; Encrypt / decrypt string
; Return : string
               
(defun zEDS ( instr / outstr c len)
  (setq c 1 len (strlen instr) outstr "")
  (while (<= c len)
    (setq outstr (strcat outstr (chr (- 255 (ascii (substr instr c 1)))))) 
    (setq c (1+ c))
  )
  outstr
)
; -------------------------------------------------------------------------------------------
; Encrypt / decrypt string-list
; Return : list

(defun zEDL ( inlist / outlist c len)
  (setq c 0 len (length inlist) outlist '())
  (while (< c len)
    (setq outlist (cons (zEDC (nth c inlist)) outlist))
    (setq c (1+ c))
  )
  (reverse outlist)
)
; -------------------------------------------------------------------------------------------
; MENGAMBIL BAGIAN LEFT/RIGHT DARI STRING DG PEMISAH CHAR. TERTENTU

(defun zStrPart (str sym side / a newstr)
  (if (= (type str) 'STR)
     (cond
       ((= side "l")            
        (setq a (substr str 2 1) newstr (substr str 1 1) str (substr str 2))
        (while (/= sym a) 
          (setq newstr (strcat newstr (substr str 1 1)) str (substr str 2) a (substr str 1 1))
        )
        (eval newstr)
       )
       ((= side "r")
        (setq a (substr str 1 1) str (substr str 2))
        (while (/= sym a) (setq a (substr str 1 1) str (substr str 2)))
       )
     )
  )
)
; -------------------------------------------------------------------------------------------
; MESSAGE / CONFIRMATION DIALOG BOX
; arg: title=dialog title, msg=message string, yesno=T->YesNo nil->Ok only, centered=T/nil

(defun zMsgBox (title msg yesno centered / makeDcl fn bkText txtList dh result)
  (defun makeDcl (fileName title textList / fh)
    (setq fh (open fileName "w"))
    (write-line "MsgBox : dialog {" fh)
    (write-line (strcat "label = \"" title "\";") fh)
    (write-line ": paragraph {" fh)
    (if centered
      (foreach item textList (write-line (strcat ": text_part {label = \"" item  "\";alignment=centered;}") fh))
      (foreach item textList (write-line (strcat ": text_part {label = \"" item  "\";}") fh))
    )
    (write-line "}" fh)
    (write-line "spacer_1;" fh)
    (if yesno
      (progn
        (write-line ": row {alignment=centered; fixed_width=true;" fh)
        (write-line ": button {key=\"BTYES\";label=\"  Yes  \";}" fh)
        (write-line ": button {key=\"BTNO\";label=\"  No  \";is_cancel=true;}" fh)
        (write-line "}" fh)
      )
      (write-line "ok_only;" fh)
    )
    (write-line "}" fh)
    (close fh)
  )
  ;;main function
  (setq fn (strcat (zSlashPath(getenv "TEMP")) "$msgbox.dc$"))  
  (while (wcmatch msg (strcat "*\n*"))
    (setq bkText (zStrPart msg "\n" "l") msg (zStrPart msg "\n" "r") txtList (cons bkText txtList))
  )
  (setq txtList (reverse (cons msg txtList)))
  (makeDcl fn title txtList)
  (setq dh (load_dialog fn))
  (if (and dh (new_dialog "MsgBox" dh))
     (progn
       (if yesno (action_tile "BTYES" "(done_dialog 1)")) 
       (set_tile "message" msg) (if (= (start_dialog) 1) (setq result T) (setq result nil))
       (unload_dialog dh)
     ) ;Progn
  );If
  result
)
; -------------------------------------------------------------------------------------------
; CLEAR ERROR TILE
(defun zCE ()(set_tile "error" ""))

; -------------------------------------------------------------------------------------------
; END OF ROUTINES
; ===========================================================================================

  (setq _a (strcat 
    (zEDS "߹߾߉") 
    "\n"
    (zEDS "ߝ߳߻")
    "\n"
    (zEDS "Ғߒǒќ")
    "\n \n"
    (zEDS "ߐߙߌߞ")
    "\n"
    (zEDS "Гǒќ")
  ))

  (setq _aa (strcat 
    "Slide Factory . AutoLISP version" 
    "\n"
    "Written by Lintang Darudjati"
    "\n"
    "e-mail: mail@lintang.8m.com"
    "\n \n"
    "Get other freeware stuff at:"
    "\n"
    "http://lintang.8m.com/"
  ))

  (defun zgetfnames ( / c cc len lenn f tmplist tmpstr)
    ;create dwglist ("abcd.dwg" "cdef.dwg" "xyz.deg") by reading dwg list file
    (setq f (open (strcat tempdir "$dwg.ls$") "r"))
    (setq c "")
    (setq dwglist '())
    (while (/= c nil)
      (if (/= nil (setq c (read-line f)))
        (setq dwglist (cons c dwglist))
      )
    )
    (close f)
    (setq dwglist (reverse dwglist))
    
    ;create name-only-list from dwglist
    (setq c 0)
    (setq len (length dwglist))
    (setq namelist '())
    (while (< c len)
      (setq tmplist (reverse (cdr (reverse (zStrParse (nth c dwglist) '(".") nil)))))
      (setq cc 0)
      (setq lenn (length tmplist))
      (setq tmpstr "")
      (while (< cc lenn)
        (setq tmpstr (strcat tmpstr (nth cc tmplist)))
        (setq cc (1+ cc))      
      )
      (setq namelist (cons tmpstr namelist))
      (setq c (1+ c))
    )
    (setq namelist (reverse namelist))
    
    ;create slide-list-file
    (setq c 0)
    (setq len (length namelist))
    (setq f (open (strcat tempdir "$sld.ls$") "w"))
    (while (< c len)
      (write-line (strcat dir (nth c namelist) ".sld") f)
      (setq c (1+ c))
    )
    (close f)
    
  );defun
    
  (defun zgocreate ( / f c len scrfile)                 
    (setq scrfile (strcat tempdir "sldfac.scr"))
    (setq c 0)
    (setq len (length dwglist))
    (setq f (open scrfile "w"))
    (while (<= c len)
      (if (= c len)
        (if (= (getvar "DWGTITLED") 1)
          (if isdos
            (write-line (strcat "_open " (getvar "DWGNAME")) f)
            (write-line (strcat "_open \"" (getvar "DWGPREFIX") (getvar "DWGNAME") "\"" ) f)
          )
          (write-line "_new " f)
        )
        (progn
          (if isdos
            (write-line (strcat "_open " dir (nth c dwglist)) f)
            (write-line (strcat "_open \"" dir (nth c dwglist) "\"" ) f)
          )
          (write-line "_mslide " f)
        )
      );if
      (setq c (1+ c))
    );while
    (if (= islib "Y")
      (if isdos
        (progn
          (write-line 
            (strcat
            "shell "
            (findfile "slidelib.exe")
            " "
            (strcat dir libname)
            " <"
            (strcat tempdir "$sld.ls$")
            ) f
          );write-line
        );progn
        (progn
          (write-line 
            (strcat
            "shell \""
            (findfile "slidelib.exe")
            "\" \""
            (strcat dir libname)
            "\" <\""
            (strcat tempdir "$sld.ls$")
            "\""
            ) f
          );write-line
        );progn
      );if
    );if
    (if isdos
      (write-line (strcat "shell " "del " (strcat tempdir "$*.*$")) f)
      (write-line (strcat "shell " "del \"" (strcat tempdir "$*.*$") "\"") f)
    )
    (write-line "(load \"sldfac\")" f)
    (close f)
    (command ".script" scrfile)
  );defun


  (if (= (getvar "DBMOD") 0)
    (progn
      (setq lenp (strlen (setq strp (getvar "PLATFORM"))))
      (setq cp 1)
      (while (<= cp lenp)
        (if (= "DOS" (substr strp cp 3))
          (progn
            (setq isdos T)
            (setq cp 255)
          )
          (setq isdos nil)
        )
        (setq cp (1+ cp))
      )
      (setq tempdir (zSlashPath(getenv "TEMP")))
      (zMsgBox "Slide Factory" _a nil T)
      (if (/= nil (setq dir (zExtractPath (getfiled "Select a file to get folder" (getvar "DWGPREFIX") "dwg" 2) T)))
        (progn
          (princ (strcat "\nSelected folder: " dir))
          
          ;create dwg list-file (dos dir command)
          (if isdos
            (command "shell" 
                (strcat
                  "dir "
                  dir
                  "*.dwg"
                  " /b/on/l>"
                  (strcat tempdir "$dwg.ls$") 
                )
            )
            (command "shell" 
                (strcat
                  "dir \""
                  dir
                  "*.dwg\""
                  " /b/on/l>\""
                  (strcat tempdir "$dwg.ls$") 
                  "\""
                )
            )
          )
          ;slide library prompt
          (initget 1 "Y N") 
          (if (= "Y" (setq islib (getkword "\nCreate slide library ? (Y/N) ")))
            (while (= nil (zStrParse (setq libname (getstring T "Slide library filename: ")) '(" ") nil))
              ();filename validity loop
            )
          )
          
          ;proceed
          (zgetfnames)
          (zgocreate)
        );progn
      );if
    );progn
    (zMsgBox "Slide Factory" 
      (strcat "Drawing has been changed.\n" "Save it first.") 
      nil T
    )
  );if
  (princ)
);defun

; -------------------------------------------------------------------------------------------
(setvar "CMDECHO" 0)
(princ "\nSlide Factory . AutoLISP version . C:SLDFAC")
(princ "\nBy Lintang Darudjati . http://lintang.8m.com/")
(princ)

